/* 
 *
 * Copyright (c) <2010> Comarch S.A. and/or its subsidiary(-ies).
 * All rights reserved.
 * This component and the accompanying materials are made available
 * under the terms of the License "Eclipse Public License v1.0"
 * which accompanies this distribution, and is available
 * at the URL "http://www.eclipse.org/legal/epl-v10.html".
 *
 * Original Contributors:
 * Comarch S.A. - original contribution.
 *
 * Contributors:
 *
 * Description:
 *
 */

#ifndef FEATUREPROVIDERBASE_H_
#define FEATUREPROVIDERBASE_H_

#include <e32base.h>

class CHsHFPCommand;

/**
 * @brief Observer of feature's class
 */
class MHsHFPFeatureProviderObserver
    {
public:
    /**
     * Callback method indicates that procedure is finished
     * 
     * @param aErr KErrNone if procedure finishes successfully, 
     * otherwise one of the system-wide error codes
     */
    virtual void HandleProcedureCompleted(TInt aErr) = 0
    };

/**
 * @brief Abstract class for particular features 
 */
class MHsHFPProcedureCommons
    {
public:
    /**
     * Processes AT command and prepares response
     * 
     * @param aInputCmd input AT command
     * @param aOutputCmd response
     * 
     * @return KErrNone if successful, otherwise one of the system-wide error
     * codes
     */
    virtual TInt ProcessCommand(const CHsHFPCommand &aInputCmd,
            CHsHFPCommand &aOutputCmd) = 0;
    };

#endif /* FEATUREPROVIDERBASE_H_ */
