/* 
 *
 * Copyright (c) <2010> Comarch S.A. and/or its subsidiary(-ies).
 * All rights reserved.
 * This component and the accompanying materials are made available
 * under the terms of the License "Eclipse Public License v1.0"
 * which accompanies this distribution, and is available
 * at the URL "http://www.eclipse.org/legal/epl-v10.html".
 *
 * Original Contributors:
 * Comarch S.A. - original contribution.
 *
 * Contributors:
 *
 * Description:
 *
 */

#ifndef HFPCOD_H_
#define HFPCOD_H_

#include <hscodpluginbase.h>

/** HFP Class of Device */
const TUint32 KHsHFPDeviceClass = 0x200408;

/**
 * @brief Manages Class of Device.
 */
class CHsHFPCoD : public CHsCoDBase
    {
public:
    /**
     * Two-phase constructor
     * 
     * @return instance of class
     */
    static CHsHFPCoD* NewL();

    /**
     * Two-phase constructor
     * 
     * @return instance of class
     */
    static CHsHFPCoD* NewLC();

    /**
     * Destructor
     */
    ~CHsHFPCoD();

    /**
     * Sets new Class of Device
     */
    void SetNewCodL();

private:
    /**
     * Constructor for performing 1st stage construction
     */
    CHsHFPCoD();

    /**
     * Constructor for performing 2nd stage construction
     */
    void ConstructL();
    };

#endif /* HFPCOD_H_ */
