/* 
 *
 * Copyright (c) <2010> Comarch S.A. and/or its subsidiary(-ies).
 * All rights reserved.
 * This component and the accompanying materials are made available
 * under the terms of the License "Eclipse Public License v1.0"
 * which accompanies this distribution, and is available
 * at the URL "http://www.eclipse.org/legal/epl-v10.html".
 *
 * Original Contributors:
 * Comarch S.A. - original contribution.
 *
 * Contributors:
 *
 * Description:
 *
 */

#ifndef HSPCOD_H_
#define HSPCOD_H_

#include <hscodpluginbase.h>

/** HSP Class of Device */
const TUint32 KHsHSPDeviceClass = 0x200404;

/**
 * @brief Manages Class of Device.
 */
class CHsHSPCoD : public CHsCoDBase
{
public:
    /**
     * Two-phase constructor
     * 
     * @return instance of class
     */
    static CHsHSPCoD* NewL();

    /**
     * Two-phase constructor
     * 
     * @return instance of class
     */
    static CHsHSPCoD* NewLC();

    /**
     * Destructor
     */
    ~CHsHSPCoD();

public:

    /**
     * Sets new Class of Device
     */
    void SetNewCodL();

private:
    /**
     * Constructor for performing 2nd stage construction
     */
    void ConstructL();
};

#endif /* HSPCOD_H_ */
